<template>
    <div class="error_mover" :class="classes">
        <el-tooltip content="Press to move to the next invalid field" placement="top">
            <el-button circle @click="moveNext" type="danger"><i class="el-icon-warning-outline error_mover__icon"></i></el-button>
        </el-tooltip>
    </div>
</template>

<script>
import { mapState } from 'vuex';
import { delay } from '@bloomio/spa-admin-common/utils';

/**
 * This component requires registered 'validation' vuex module for the work
 */

export default {
    watch: {
        messages: {
            handler(newVal) {
                this.ids = this.generateInvalidIds(newVal);
                if (this.ids.length) {
                    if (this.currentIndex === null) {
                        this.moveScrollTo(0);
                    }
                } else {
                    this.current = '';
                    this.currentIndex = null;
                }
            },
            deep: true,
        },
    },
    data() {
        return {
            currentIndex: null,
            ids: [],
            needShow: false,
            timer: null,
        };
    },
    computed: {
        ...mapState({
            messages: state => state.validation.validationMessages,
            invalidIdToScroll: state => state.validation.invalidIdToScroll,
        }),
        classes: vm => ({ visible: vm.needShow }),
        current: {
            get() {
                return this.invalidIdToScroll;
            },
            set(newVal) {
                this.$store.commit('setlInvalidIdToScroll', newVal);
            },
        },
    },
    methods: {
        /**
         * Generated parameter UIDs from server answer object
         * @param {Object} obj - invalid parameters from server
         * @param {String} key - header part of the UID
         */
        generateInvalidIds(obj, key = null) {
            const separator = '.';
            return Object.entries(obj).reduce((acc, [k, v]) => {
                let nested = [];
                const keyPath = key !== null ? `${key}${separator}${k}` : k;
                if (typeof v === 'object' && Object.prototype.hasOwnProperty.call(v, 'message')
                    && (!Object.prototype.hasOwnProperty.call(v, 'invalid') || v.invalid)) { // the last level
                    acc.push(keyPath);
                } else if (!(Object.prototype.hasOwnProperty.call(v, 'invalid') && !v.invalid)) { // nested object
                    nested = this.generateInvalidIds(v, keyPath);
                }
                return [...acc, ...nested];
            }, []);
        },
        /**
         * Checks if DOM element in the viewport
         * @param {DOMObject} el - dom element
         */
        isInViewport(el) {
            if (el) {
                const bounding = el.getBoundingClientRect();
                const condTopLeft = bounding.top >= 0 && bounding.left >= 0;
                const viewportHeight = window.innerHeight || document.documentElement.clientHeight;
                const viewportWidth = window.innerWidth || document.documentElement.clientWidth;
                const actionPanelHeight = 80; // to except overlap element by the panel
                const condBottomRight = (bounding.bottom + actionPanelHeight) <= (viewportHeight + bounding.height) / 2
                    && bounding.right <= viewportWidth;
                return condTopLeft && condBottomRight;
            }
            return false;
        },
        /**
         * Scroll next invalid parameter
         */
        moveNext() {
            if (this.ids.length) {
                const ind = (this.currentIndex === (this.ids.length - 1) || this.currentIndex >= this.ids.length) ? 0 : this.currentIndex + 1;
                this.moveScrollTo(ind);
            }
        },
        /**
         * Scroll page to the invalid parameter
         * @param {String} ind - array index for ids
         */
        moveScrollTo(ind) {
            if (this.current === this.ids[ind]) {
                return;
            }
            this.currentIndex = ind;
            this.current = this.ids[ind];

            // delay for finishing opening animations for parent collapse sections
            delay(500).then(() => {
                const element = window.document.getElementById(this.ids[ind]);
                if (element) {
                    if (!this.isInViewport(element)) {
                        element.scrollIntoView({ behavior: 'smooth', block: 'center' });
                    }
                    this.updateShowFlag();
                }
            });
        },
        /**
         * On timer checks element in the viewport and shows/hides button for moving to the next invalid element
         */
        updateShowFlag() {
            if (this.timer) {
                clearTimeout(this.timer);
            }
            this.timer = setTimeout(() => {
                this.needShow = this.ids.length > 1 && this.ids.some(id => !this.isInViewport(window.document.getElementById(id)));
                this.timer = null;
            }, 500);
        },
    },
};
</script>

<style lang="stylus" scoped>
.error_mover
    display: inline-block
    position: fixed
    z-index: 10000
    bottom: 9rem
    right : 3rem
    visibility: hidden
    transition: visibility 1s ease-out

.el-button
    padding: 0 !important

.error_mover__icon
    font-size: 3rem

.visible
    visibility: visible

.rotate-down
    transform: rotate(-90deg)
</style>
